% fn_eval_grad.m

function grad = fn_eval_grad(u, x, params, data)

  [T PSI] = ode23(@(t,psi) fn_Lotka_Volterra_adj(t, psi, params, data, u, x), ...
                  data(end:-1:1,1), [-2*params(9)*(x(end,1)-data(end,2)) -2*params(10)*(x(end,2)-data(end,3))]);

  % computing gradient - reverting time as adjoint problem is solved backward in time
  grad = x(:,1).*PSI(end:-1:1,1) + x(:,2).*PSI(end:-1:1,2);
  
  % updating regularization part
  grad(end) = grad(end) + 2 * params(11) * (u(end)-params(12));
  
return