% initialize.m
%
% Initialization procedure for Chapter_12_opt_pde.m
%

% creating & saving mesh by calling FreeFEM code mesh.edp
paramsLine = ['-p1 ' num2str(b) ' -p2 ' num2str(nx)];
[status, cmdout] = system(['FreeFem++ freefem/mesh.edp ' paramsLine]);
if fn_stat(status, 0, cmdout, ffDebug)
  return;
end

% initializing variables and vectors
k = 0;                   % number of iterations
obj = [];                % objective function evaluations
aHist = [];              % history of control changes
aNorm = [];              % L2 norm for control difference
alpha = [];              % stepsize records
exCode = 3;              % OPT termination condition (#1, #2 or #3)
% vector of parameters to be passed into functions
params = [b visDiscr ffDebug];

% initializing golden section search parameters (if GS is chosen)
if strcmp(methodAlpha,'GS')
  alphaGS = (-1+sqrt(5))/2;
  if (alphaEps <= 0) || (alphaEps >alphaB-alphaA)
    disp('Incorrect epsilon!!!');
    return;
  end
end

% function handlers
f           = @fn_eval_obj;       % for objective function
grad        = @fn_eval_grad;      % for gradient
