% fn_eval_obj.m

function [obj aNorm] = fn_eval_obj(step, a, d, params)

  % updating control
  a = a + step*d;

  % saving updated control in file
  fid = fopen('temp/opt_a.dat', 'w');
  fprintf(fid, '%d\r\n', length(a));
  for i=1:length(a)
    fprintf(fid, '%1.20e\r\n', a(i));
  end
  fclose(fid);

  % forward simulation with objective evaluation by calling FreeFEM code eval_obj.edp
  paramsLine = ['-p1 ' num2str(params(1)) ' -p2 ' num2str(params(2))];
  [status, cmdout] = system(['FreeFem++ freefem/eval_obj.edp ' paramsLine]);
  fn_stat(status, 0, cmdout, params(3));

  objFunc = load('temp/opt_obj.dat');
  obj = objFunc(1);
  aNorm = objFunc(2);
  
return