% params.m
%
% Chapter_12_opt_pde.m
%

% choosing mode & solution method
mode   = 'OPT';                  % OPT or TEST
method = 'CG';                   % SD, CG, BFGS
BFGSrst = 5;                     % restart parameter for BFGS

% PDE model parameters:
b = 1.0;                         % size of square domain
nx = 50;                         % number of partial intervals over 1 boundary segment

% OPT setup:
iniGuess = 0;                    % # for initial guess for control a(x)
ffDebug = true;                  % allowing all messages from FreeFem to be recorded

% [SD, CG, BFGS] - parameters for alpha-search:
methodAlpha = 'BB';              % method for alpha step size search: CONST, GS, BB
% (1) constant (CONST)
alphaConst = 1e6;
% (2) golden section (GS)
alphaA = 0; alphaB = 1e6;        % search interval [a, b]
alphaEps = 1e-6;                 % tolerance for search termination
% (3) bracketing-Brent (BB) toolbox
AXini = 0; BXini = 1e0;          % min_brack: initial bracketing interval [a, b]
MAXITER = 20;                    % min_brack: max number of iterations
GLIMIT = 100.0;                  % min_brack: maximum magnification allowed for parabolic-fit step
TOL = 1e-9;                      % Brent: tolerance
ITMAX = 2;                       % Brent: max number of iterations

% termination
epsilonJ = 1e-4;                 % tolerance (#1) relative objective decrease
epsilonA = 1e-4;                 % tolerance (#2) relative solution decrease
kMax     = 100;                  % max number of iterations (#3)

% visualization parameters
BigFigure       = true;
FontSize        = 12;
MarkerSizeBig   = 30;
MarkerSizeSmall = 20;
LineWidth       = 2.5;
visDiscr        = 200;           % visualization parameter (for FreeFEM)
pauseTime       = 0;             % pause time (in seconds)
