% Chapter_2_min_1D_PlotFunctions.m
%
% Computational Optimization: Success in Practice
% Chapter 2: Minimization Approaches for Functions of One Variable
% Section 2.7: Practical Examples
%
%  2023 by Vladislav Bukshtynov
% VladislavBukshtynov@yahoo.com
%

close all; clc;

% input parameters to set interval [a, b] and discretize x
a = -2; b = 2;
delta_x = 0.01;
x = a:delta_x:b;

% evaluating f(x) over [a, b] using fn_1_6_functions.m
fnNum = 3;
f = fn_all_functions(fnNum,x);

% Visualization
figure(1);
plot(x,f,'b-', 'LineWidth',2.5); % plotting
set(gca,'XLim',[x(1) x(end)],'FontSize',14); box off; % graph settings