% Chapter_3_data_fit_by_gradient.m
%
% Computational Optimization: Success in Practice
% Chapter 3: Generalized Optimization Framework
% Section 3.3: Choosing and Adjusting Optimization Algorithms
% Section 3.4: Visualization and Analysis of Obtained Solutions
% Section 3.5: Testing and Dealing with Problems (Debugging)
%
% Coding in MATLAB: Optimization Framework for Example 1.3
% Least-square Data Fitting by Gradient Method
%
%  2023 by Vladislav Bukshtynov
% VladislavBukshtynov@yahoo.com
%

close all; clc; clear;

% setting INPUT parameters
params;

% loading DATA
data = load(dataFile);

% INItialization
initialize;

% main OPTimization loop
while(k < kMax+1) % termination condition #2

  % f-evaluation
  obj = [obj f(a, data)];

  % visualization
  visualize;

  % termination condition #1: checking optimality (by tolerance)
  if k > 0
    err = abs(obj(end-1)-obj(end))/obj(end-1);
    if (err < epsilon)
      break;
    end
  end
    
  % search for d: computing gradient
  d = -grad(a,data);
   
  % search for alpha
  alpha = alphaConst;
  
  % update for controls
  a = a + alpha*d;
  aHist = [aHist a];
   
  % iteration counter increment
  k = k + 1;

end

% convergence analysis
fn_convergence_sol_norm([],aHist);
