% Chapter_3_data_fit_by_gradient_ver_2.m
%
% Computational Optimization: Success in Practice
% Chapter 3: Generalized Optimization Framework
% Section 3.7: Accuracy and Performance
%
% Coding in MATLAB: Optimization Framework for Example 1.3
% Least-square Data Fitting by Gradient Method
% ver. 2 improvement: choosing step size alpha by Golden Section Search
%
%  2023 by Vladislav Bukshtynov
% VladislavBukshtynov@yahoo.com
%

close all; clc; clear;

% setting INPUT parameters
params_ver_2;

% loading DATA
data = load(dataFile);

% INItialization
initialize_ver_2;

% main OPTimization loop
while(k < kMax+1) % termination condition #2

  % f-evaluation
  obj = [obj f(a, data)];

  % visualization
  visualize;

  % termination condition #1: checking optimality (by tolerance)
  if k > 0
    err = abs(obj(end-1)-obj(end))/obj(end-1);
    if (err < epsilon)
      break;
    end
  end
    
  % search for d: computing gradient
  d = -grad(a,data);
   
  % search for alpha (now with Golden Section Search)
  golden_section_search;
  alpha = [alpha alphaOpt];
  
  % update for controls
  a = a + alpha(end)*d;
  aHist = [aHist a];
   
  % iteration counter increment
  k = k + 1;

end

% convergence analysis
fn_convergence_sol_norm([],aHist);
