% Chapter_3_data_fit_by_gradient_ver_final.m
%
% Computational Optimization: Success in Practice
% Chapter 3: Generalized Optimization Framework
% Section 3.8: Communication within the Framework
%
% Coding in MATLAB: Optimization Framework for Example 1.3
% Least-square Data Fitting by Different Methods
% Included:
% - modes:    regular OPT & TEST
% - methods:  Gradient-based steepest descent (SD) & 2-nd order Newton's method
% - stepsize: constant & Golden Section (GS) Search
%
%  2023 by Vladislav Bukshtynov
% VladislavBukshtynov@yahoo.com
%

close all; clc; clear; tic;

% setting INPUT parameters
params_ver_final;

% loading DATA
data = load(dataFile);

% INItialization
initialize_ver_final;

% choosing mode
if strcmp(mode,'OPT')
  mode_OPT;
elseif strcmp(mode,'TEST')
  mode_TEST;
else
  disp(['error: Unknown mode ' mode ' is chosen!']); return;
end

% final output
fprintf(['We are fully done! CPU elapsed time = ' num2str(toc) 's\n\n']);
