% initialize.m
%
% Initialization procedure for Chapter_3_data_fit_by_gradient.m
%

% initial guess for controls
a = aini';

% saving shape of curve at initial guess
x = min(data(:,1))-1:0.01:max(data(:,1)+1);
yini = a(1)+a(2)*x+a(3)*x.^2;

% initializing variables and vectors
k = 0;     % number of iterations
obj = [];  % objective function evaluations
aHist = a; % history of control changes

% function handlers
f    = @fn_eval_f;    % for objective function f(x)
grad = @fn_eval_grad; % for gradient of f(x)
