% initialize_final.m
%
% Initialization procedure for Chapter_3_data_fit_by_gradient_ver_final.m
%

% initial guess for controls
a = aini';

% saving shape of curve at initial guess
x = min(data(:,1))-1:0.01:max(data(:,1)+1);
yini = a(1)+a(2)*x+a(3)*x.^2;

% initializing variables and vectors
k = 0;      % number of iterations
obj = [];   % objective function evaluations
aHist = a;  % history of control changes
alpha = []; % stepsize records

% initializing golden section search parameters (if GS is chosen)
if (alphaUpdate)
  alphaGS = (-1+sqrt(5))/2;
  if (alphaEps <= 0) || (alphaEps >alphaB-alphaA)
    disp('Incorrect epsilon!!!');
    return;
  end
end

% function handlers
f    = @fn_eval_f;    % for objective function f(x)
grad = @fn_eval_grad; % for gradient of f(x)
hess = @fn_eval_hess; % for Hessian of f(x)
