% mode_OPT.m
%
% OPTimization mode for Chapter_3_data_fit_by_gradient_ver_final.m
%

% main OPTimization loop
while(k < kMax+1) % termination condition #3

  % f-evaluation
  obj = [obj f(a, data)];

  % visualization
  visualize;

  % termination condition #1: checking optimality (objective change)
  if k > 0
    err1 = abs(obj(end-1)-obj(end))/abs(obj(end-1));
    if (err1 < epsilonF)
      break;
    end
  end

  % termination condition #2: checking optimality (solution change)
  if k > 0
    err2 = norm(a-a_old,2)/norm(a_old,2);
    if (err2 < epsilonA)
      break;
    end
  end
    
  % search for d: computing using Newton's method
  if strcmp(method,'SD')
    d = -grad(a,data);
  elseif strcmp(method,'NEWTON')
    d = -inv(hess(a,data))*grad(a,data);
  else
    disp(['error (OPT): Unknown method ' method ' is chosen!']); break;
  end
   
  % search for alpha (GS vs. constant)
  if (alphaUpdate)
    golden_section_search;
  else
    alphaOpt = alphaConst;
  end
  alpha = [alpha alphaOpt];
  
  % update for controls
  a_old = a;
  a = a + alpha(end)*d;
  aHist = [aHist a];
   
  % iteration counter increment
  k = k + 1;

end

% convergence analysis
fn_convergence_sol_norm([],aHist);
