% params_ver_final.m
%
% Chapter_3_data_fit_by_gradient_ver_final.m
%

% choosing mode & solution method
mode   = 'OPT';                  % OPT or TEST
method = 'SD';                   % SD or NEWTON

% main parameters
dataFile   = 'data_main.dat';    % data file
aini      = [-14 11 -2];         % initial guess

% parameters for alpha stepsize search (GS vs. constant)
alphaUpdate = true;              % golden section will be chosen if "true"
% if alpha = const
alphaConst = 10^-3;
% if alpha is chosen by GS
alphaA = 0; alphaB = 10;         % search interval [a, b]
alphaEps = 0.00001;              % tolerance for search termination

% termination
epsilonF = 1e-6;                 % tolerance (#1) relative objective decrease
epsilonA = 1e-6;                 % tolerance (#2) relative solution decrease
kMax     = 100;                  % max number of iterations (#3)

% visualization parameters
BigFigure       = true;
FontSize        = 14;
MarkerSizeBig   = 30;
MarkerSizeSmall = 20;
LineWidth       = 2.5;
pauseTime       = 2;             % pause time (in seconds)
