% Chapter_5_data_fit_by_line_search.m
%
% Computational Optimization: Success in Practice
% Chapter 5: Line Search Algorithms
% Section 5.5: Line Search Performance Comparison
%
% Coding in MATLAB: Optimization Framework for Example 1.3
% Least-square Data Fitting by Different Line Search Methods
% Included:
% - modes:    regular OPT & TEST
% - methods:  Gradient-based steepest descent (SD) & 2-order Newton's method (NEWTON)
% - ADDED:    discretized Newton's (DN)
%             modified Newton's (MN)
%             diagonally scaled SD (DSSD)
%             quasi-Newton (BFGS)
%             Gauss--Newton (GN)
%             Conjugate Gradient (CG)
% - stepsize: constant & Golden Section (GS) Search
%
%  2023 by Vladislav Bukshtynov
% VladislavBukshtynov@yahoo.com
%

close all; clc; clear; tic;

% setting INPUT parameters
params;

% loading DATA
data = load(dataFile);

% INItialization
initialize;

% choosing mode
if strcmp(mode,'OPT')
  mode_OPT;
elseif strcmp(mode,'TEST')
  mode_TEST;
else
  disp(['error: Unknown mode ' mode ' is chosen!']); return;
end

% final output
fprintf(['We are fully done! CPU elapsed time = ' num2str(toc) 's\n\n']);
