% fn_eval_hess_approx.m
%
% Function to evaluate approximated Hessian of the objective function
% by using FD
%

function hess = fn_eval_hess_approx(a, data, da, f)
  
   hess(1,1) = f(a+[2*da 0 0]',data) - 2*f(a+[da 0 0]',data) + f(a,data);
   hess(1,2) = f(a+[da da 0]',data) - f(a+[0 da 0]',data) - f(a+[da 0 0]',data) + f(a,data);
   hess(1,3) = f(a+[da 0 da]',data) - f(a+[0 0 da]',data) - f(a+[da 0 0]',data) + f(a,data);
   hess(2,1) = hess(1,2);
   hess(2,2) = f(a+[0 2*da 0]',data) - 2*f(a+[0 da 0]',data) + f(a,data);
   hess(2,3) = f(a+[0 da da]',data) - f(a+[0 0 da]',data) - f(a+[0 da 0]',data) + f(a,data);
   hess(3,1) = hess(1,3);
   hess(3,2) = hess(2,3);
   hess(3,3) = f(a+[0 0 2*da]',data) - 2*f(a+[0 0 da]',data) + f(a,data);
   
   hess = hess./da^2;
   
return