% Chapter_6_data_fit_by_line_search.m
%
% Computational Optimization: Success in Practice
% Chapter 6: Choosing Optimal Step Size
% Section 6.4: Step Size Performance Comparison
% Section 6.8: Bracketing-Brent Toolbox Performance
%
% Coding in MATLAB: Optimization Framework for Example 1.3
% Least-square Data Fitting by Different Line Search Methods
% Included:
% - modes:    regular OPT & TEST
% - methods:  steepest descent (SD)
%             Newton's method (NEWTON)
%             discretized Newton's (DN)
%             modified Newton's (MN)
%             diagonally scaled SD (DSSD)
%             quasi-Newton (BFGS)
%             Gauss--Newton (GN)
%             Conjugate Gradient (CG)
% - stepsize: constant (CONST) & Golden Section (GS) Search
% - ADDED:    diminishing (DIM)
%             backtracking line search (BLS)
%             BLS with Wolfe conditions (BLSW)
%             BLS with strong Wolfe conditions (BLSSW)
%             BLS with Goldstein conditions (BLSG)
%             bracketing-Brent toolbox (BB)
%
%  2023 by Vladislav Bukshtynov
% VladislavBukshtynov@yahoo.com
%

close all; clc; clear; tic;

% setting INPUT parameters
params;

% loading DATA
data = load(dataFile);

% INItialization
initialize;

% choosing mode
if strcmp(mode,'OPT')
  mode_OPT;
elseif strcmp(mode,'TEST')
  mode_TEST;
else
  disp(['error: Unknown mode ' mode ' is chosen!']); return;
end

% final output
fprintf(['We are fully done! CPU elapsed time = ' num2str(toc) 's\n\n']);
