% golden_section_search.m
%
% Algorithm for stepsize search:
% - Golden Section Search
% - used for Chapter_5_data_fit_by_line_search.m  and up
%

% new variables for a & b as alphaA, alphaB should be preserved for future use!
aa = alphaA; bb = alphaB;

% setting initial values for k, d
kk = 1; dd = bb - aa;

% 1st approximation for optimal solution
alphaOpt = (aa+bb)/2;

% search loop
while(dd >= alphaEps)  % termination criterion
  x1 = alphaGS*aa + (1-alphaGS)*bb;
  x2 = (1-alphaGS)*aa + alphaGS*bb;
  
  if kk == 1
    f1 = f(a+x1*d,data); f2 = f(a+x2*d,data);
  else
    if abs(x2-alphaOpt)<abs(x1-alphaOpt)
      f2 = f1; f1 = f(a+x1*d,data);
    else
      f1 = f2; f2 = f(a+x2*d,data);
    end
  end
  
  if (f1 <= f2)
    bb = x2; alphaOpt = x1;
  else
    aa = x1; alphaOpt = x2;
  end

  dd = bb-aa;
  
  kk = kk + 1;
  
end
