% mode_OPT.m
%
% OPTimization mode for Chapter_6_data_fit_by_line_search.m
%

% main OPTimization loop
while(k < kMax+1) % termination condition #3

  % f-evaluation
  obj = [obj f(a, data)];

  % visualization
  visualize;

  % termination condition #1: checking optimality (objective change)
  if k > 0
    err1 = abs(obj(end-1)-obj(end))/abs(obj(end-1));
    if (err1 < epsilonF)
      exCode = 1;
      break;
    end
  end

  % termination condition #2: checking optimality (solution change)
  if k > 0
    err2 = norm(a-a_old,2)/norm(a_old,2);
    if (err2 < epsilonA)
      exCode = 2;
      break;
    end
  end
    
  % search for d
  direction_search;
   
  % search for alpha
  stepsize_search;
  alpha = [alpha alphaOpt];
  
  % update for controls
  a_old = a;
  a = a + alpha(end)*d;
  aHist = [aHist a];
   
  % iteration counter increment
  k = k + 1;

end

if (exCode==3)
  k = k - 1;
end

% convergence analysis
fn_convergence_sol_norm([],aHist);
