% kappa_test.m
%
% Kappa-test for Chapter_5_data_fit_by_line_search.m and up
%

% Kappa-test #1: cheap test
dotPr = d'*a;
for k = 1:16
  eps(k) = 10^(k-16);
  kappaC(k) = (f(a+eps(k)*a,data)-obj)/(eps(k)*dotPr);
end

% Kappa-test #2: expensive test
epS = 10^-8;
for i = 1:length(a)
  a_new = zeros(size(a)); a_new(i) = a(i);
  kappaE(i) = (f(a+epS*a_new,data)-obj)/(epS*d(i)*a(i));
end

% visualization for cheap kappa-test #1
figure(1);
semilogx(eps,kappaC,'r.-','MarkerSize',MarkerSizeSmall,'LineWidth', LineWidth); hold on;
plot([eps(1) eps(end)], [1 1], '--k'); axis([eps(1) eps(end) 0.99 1.01]);
xlabel('\epsilon','FontSize',FontSize); ylabel('\kappa(\epsilon)','FontSize',FontSize);
title('kappa-test (cheap)','FontSize',FontSize);
set(gca,'FontSize',FontSize-2); box off;

figure(2);
loglog(eps,abs(kappaC-1),'r.-','MarkerSize',MarkerSizeSmall,'LineWidth', LineWidth); hold on;
xlabel('\epsilon','FontSize',FontSize); ylabel('| \kappa(\epsilon) - 1|','FontSize',FontSize);
title('kappa-test (cheap)','FontSize',FontSize);
set(gca,'XLim',[eps(1) eps(end)],'FontSize',FontSize-2); box off;

% visualization for expensive kappa-test #2
figure(3);
semilogy(1:length(a),abs(kappaE-1),'r.','MarkerSize',MarkerSizeSmall); hold on;
xlabel('control/gradient component #, i','FontSize',FontSize); ylabel('| \kappa(i) - 1|','FontSize',FontSize);
title('kappa-test (expensive)','FontSize',FontSize);
set(gca,'XLim',[0 length(a)],'XTick',1:length(a),'FontSize',FontSize-2); box off;
