% fn_eval_hess.m
%
% Function to evaluate Hessian of the objective function
%

function hess = fn_eval_hess(a, data)
  
   hess(1,1) = size(data,1);
   hess(1,2) = sum(data(:,1));
   hess(1,3) = sum(data(:,1).^2);
   hess(2,1) = hess(1,2);
   hess(2,2) = hess(1,3);
   hess(2,3) = sum(data(:,1).^3);
   hess(3,1) = hess(2,2);
   hess(3,2) = hess(2,3);
   hess(3,3) = sum(data(:,1).^4);
   
   hess = 2*hess;
  
return