% fn_eval_f_grad.m
%
% Function to evaluate gradient of the objective function
%

function grad_f = fn_eval_f_grad(a, data)
   
  if (~data(1))  
    grad_f(1) = 2*a(1) + a(2) + a(3) - 4;
    grad_f(2) = a(1) + 2*a(2) + a(3) - 4;
    grad_f(3) = a(1) + a(2) + 2*a(3) - 4;
    grad_f(4) = 0;
  else
    grad_f(1) = a(1) + 2*data(2)*(sum(a)-4);
    grad_f(2) = a(2) + 2*data(2)*(sum(a)-4);
    grad_f(3) = a(3) + 2*data(2)*(sum(a)-4);
    grad_f(4) = a(4) + 2*data(2)*(sum(a)-4);
  end
  
  grad_f = grad_f';
  
return