% fn_eval_hess.m
%
% Function to evaluate Hessian of the objective function
%

function hess = fn_eval_hess(a, data)
  
  if (~data(1))
    % 4th row & 4th column are added
    % to match the structure of 4-component gradient
    hess = [2 1 1 0; ...
            1 2 1 0; ...
            1 1 2 0; ...
            0 0 0 1];
  else
    hess = 2*data(2)*ones(4,4) + eye(4,4); 
  end
  
return