% params.m
%
% Chapter_8_opt_constrained.m
%

% choosing mode & solution method
mode   = 'OPT';                % OPT or TEST
method = 'SD';                 % SD, NEWTON, BFGS, CG (all other deactivated)
stepH  = 1e-4;                 % FD approximation step (for Hessian)

% main parameters
aini   = [5 -3 8 5];           % initial guess
exMethod = 0;                  % chosen method: 0 - Lagrange multiplier, 1 - penalization
penalCoeff = 1;                % penalization coefficient

% [SD, NEWTON, DN, MN, DSSD, BFGS, GN, CG] - parameters for alpha-search:
methodAlpha = 'BB';          % method for alpha step size search: CONST, GS, DIM, BLS, BLSW, BLSSW, BLSG, BB
% (1) constant (CONST)
alphaConst = 1e-4;
% (2) golden section (GS)
alphaA = 0; alphaB = 10;       % search interval [a, b]
alphaEps = 1e-6;               % tolerance for search termination
% (3&4) diminishing (DIM) or BLS(W,SW,G)
alphaIni = 1.0;                % initial alpha value
alphaRho = 0.25;               % contraction factor
alphaC = 0.1;                  % c (or c1) parameter in BLS, BLSW, BLSSW, BLSG
alphaCw = 0.5;                 % c2 parameter in BLSW and BLSSW
% (5) bracketing-Brent (BB) toolbox
AXini = 0; BXini = 1;          % min_brack: initial bracketing interval [a, b]
MAXITER = 20;                  % min_brack: max number of iterations
GLIMIT = 100.0;                % min_brack: maximum magnification allowed for parabolic-fit step
TOL = 1e-6;                    % Brent: tolerance
ITMAX = 2;                     % Brent: max number of iterations

% [TRDL] - parameters for trust region method:
deltaTRmax = 5.0;                % max size (radius) of trust region
paramTR = 1/8;                   % trust-region parameter from [0, 1/4]

% [BF] - parameters for brute-force method:
aMin = [-50 -50 -50 -50];        % search direction limits
aMax = [ 50  50  50 50];
bfStep = [2 2 2 2];              % step size for each direction

% [MC] - parameters for stochastic Monte-Carlo method:
mcN = 100;                       % number of samples
mcDist = 'NORM';                 % distribution method: UNIF or NORM
% parameters for UNIF
mcMin = [-50 -50 -50 -50];       % search intervals
mcMax = [ 50  50  50 50];
% parameters for NORM
mcMean = [0 0 0 0];              % means
mcSigma = [50/3 50/3 50/3 50/3]; % standard deviations

% termination
epsilonF = 1e-6;               % tolerance (#1) relative objective decrease
epsilonA = 1e-6;               % tolerance (#2) relative solution decrease
kMax     = 200;                % max number of iterations (#3)

% visualization parameters
BigFigure       = true;
FontSize        = 14;
MarkerSizeBig   = 30;
MarkerSizeSmall = 20;
LineWidth       = 2.5;
pauseTime       = 2;           % pause time (in seconds)
