% params.m
%
% Chapter_9_opt_lotka_volterra.m
%

% choosing mode & solution method
mode   = 'OPT';                  % OPT or TEST
method = 'SD';                   % SD, CG, BFGS
BFGSrst = 5;                     % restart parameter for BFGS

% LV model parameters:
% t-domain
ti = 0; tf = 15;                 % t-domain
Nt = 100;                        % number of discrete intervals in t-domain
% x-solution
x1i = 50.0; x2i = 50.0;          % initial conditions for IVP in LV model
% coefficients in the LV model
paramsODE = [1.0 0.01 1.0 0.02]; % alpha, beta, gamma, delta
modelU = 2;                      % exact u(t) model number (1, 2, 3)

% OPT setup:
objWeight = [1.0 1.0];           % weight coefficients in objective
u_ini = 0.5;                     % initial guess for u(t) - constant

% [SD, CG, BFGS] - parameters for alpha-search:
methodAlpha = 'BB';              % method for alpha step size search: CONST, GS, BB
% (1) constant (CONST)
alphaConst = 1e-4;
% (2) golden section (GS)
alphaA = 0; alphaB = 1e-6;       % search interval [a, b]
alphaEps = 1e-9;                 % tolerance for search termination
% (3) bracketing-Brent (BB) toolbox
AXini = 0; BXini = 1e-6;         % min_brack: initial bracketing interval [a, b]
MAXITER = 20;                    % min_brack: max number of iterations
GLIMIT = 100.0;                  % min_brack: maximum magnification allowed for parabolic-fit step
TOL = 1e-9;                      % Brent: tolerance
ITMAX = 2;                       % Brent: max number of iterations

% termination
epsilonJ = 1e-9;                 % tolerance (#1) relative objective decrease
epsilonU = 1e-9;                 % tolerance (#2) relative solution decrease
kMax     = 200;                  % max number of iterations (#3)

% visualization parameters
BigFigure       = true;
FontSize        = 12;
MarkerSizeBig   = 30;
MarkerSizeSmall = 20;
LineWidth       = 2.5;
pauseTime       = 2;             % pause time (in seconds)
